//+------------------------------------------------------------------+
//|                                                      defines.mqh |
//|                                  Copyright 2012, Roman Martynyuk |
//|                                           http://www.dml-ewa.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright 2012, Roman Martynyuk"
#property link      "http://www.dml-ewa.ru/"

#include <Arrays\ArrayDouble.mqh>

// ewm
#define PREV_LEVEL             'Q'      //       
#define NEXT_LEVEL             'W'      //       
#define DOWN_LEVEL             'A'      //    
#define UP_LEVEL               'S'      //    
#define START_MARKING          'Z'      //   
#define STOP_MARKING           'X'      //   
#define SELECT_GROUP           0x09     // /     ( Tab)
#define HIDE_PANEL             0x1B     // /   ( Esc)
#define INCREASE_LEVEL         'E'      //    ,   
#define REDUCE_LEVEL           'R'      //    ,   
#define DELETE_OBJECT          0x2E     //    ( Del)
#define SELECT                 0x10     // /    ( Shift)
#define SHIFT_X                3        //      X
#define SHIFT_Y                5        //      Y
#define UP                     true     //   
#define DOWN                   false    //   
#define LEVEL                  0        //   
#define TEXT                   1        //  
#define GROUP                  2        //   
#define UNIQUE_NAME            3        //    ,    
#define LABELS                 15       //     
#define DELAY                  100      //    
#define TOP                    true     //     
#define BOTTOM                 false    //     
#define EVERY_BAR              1        //     /   
#define NOT_EVERY_BAR          0        //      /  
#define SEPARATOR              "_"      // 
#define NAME_LABEL             "$L$"    //     
#define NAME_WAVE              "$W$"    //   

// ewa
#define START_ANALYSIS_LEFT    '1'      //   /    
#define START_ANALYSIS_RIGHT   '2'      //   /    
#define PREV_VARIANT_LEFT      '3'      //      
#define NEXT_VARIANT_LEFT      '4'      //      
#define PREV_VARIANT_RIGHT     '5'      //     ,    
#define NEXT_VARIANT_RIGHT     '6'      //     ,    
#define CONVERT                'V'      //     
#define CLEAR                  'C'      //  
#define GET_NAME_WAVE_LEFT     '7'      //    
#define GET_NAME_WAVE_RIGHT    '8'      //   ,    
#define NAME_AUTO_WAVE         "$A$"    //    ,    
#define MAX_POINTS             6        //      
#define TREND_UP               "Up"     //  
#define TREND_DOWN             "Down"   //  
#define MORE                   ">="     //   
#define LESS                   "<="     //   
#define MIN                    "min"    //   
#define MAX                    "max"    //   
#define VAL                    "val"    //  
#define LENGTH                 "length" //   
#define TIME                   "time"   //   
#define EOF                    26       //   
#define LEFT                   true     // 
#define RIGHT                  false    // 
#define TYPE1                  1        //   -   
#define TYPE2                  2        //   -   
#define TYPE3                  3        //   -   
#define TYPE4                  4        //   -     
#define MSG_BEGIN_ANALYSIS     " ?"
#define MSG_SELECTED_MORE      "  , ..    !"
#define MSG_ANALYSIS_COMPLETED " !"
#define MSG_REMOVE             "   !"
#define MSG_CLEAR              "    ?"
#define NAME_RULES_FILE        "EWM.txt"
#define MSG_FILE_OPEN_ERROR    "   EWM.txt!"

#define COPY_CHART             'J'      //      

// pitchfork
#define SHOW_SCHIFF            'U'
#define SHOW_WARNING_UP        'D'
#define SHOW_WARNING_DOWN      'F'
#define NAME_PITCHFORK         "$P$"
#define NAME_SCHIFF            "$S$"
#define NAME_REACTION          "$R$"
#define NAME_WARNING_UP        "$WU$"
#define NAME_WARNING_DOWN      "$WD$"
#define PITCHFORK_LEVEL1       0
#define PITCHFORK_TEXT1        1
#define PITCHFORK_GROUP1       2
#define PITCHFORK_LEVEL2       3
#define PITCHFORK_TEXT2        4
#define PITCHFORK_GROUP2       5
#define PITCHFORK_LEVEL3       6
#define PITCHFORK_TEXT3        7
#define PITCHFORK_GROUP3       8
#define PITCHFORK_NAME         9
#define PITCHFORK_VISIBLE      10
#define HIDE_PITCHFORK         'P'
#define NAME_PRICE_LABEL       "$PL$"
#define NAME_HORIZONTAL        "$H$"
#define NAME_VERTICAL          "$V$"
#define NAME_VERTICAL0         "$V0$"
#define SHOW_HORIZONTAL        'T'
#define HIDE_ALL_HORIZONTAL    'Y'
#define SHOW_PRICE_LABEL       'G'
#define HIDE_ALL_PRICE_LABEL   'H'
#define SHOW_VETICAL           'B'
#define HIDE_ALL_VERTICAL      'N'
#define SHOW_VERTICAL0         'M'

double schiff_levels1[]   = {-0.764, -1.000};
double schiff_levels2[]   = {-0.764, -1.000, 0.000};
double pitchfork_levels[] = {-0.764};

CArrayDouble warning_levels;
CArrayDouble reaction_levels;

string etalon[] = {"1", "2", "3", "4", "5", "A", "B", "C", "D", "E", "W", "X", "Y", "XX", "Z"};

MqlRates rates[];

// ,    
int tfs[] = {OBJ_PERIOD_M1, OBJ_PERIOD_M2, OBJ_PERIOD_M3, OBJ_PERIOD_M4, OBJ_PERIOD_M5, OBJ_PERIOD_M6, OBJ_PERIOD_M10, OBJ_PERIOD_M12, OBJ_PERIOD_M15, OBJ_PERIOD_M20, OBJ_PERIOD_M30, OBJ_PERIOD_H1, OBJ_PERIOD_H2, OBJ_PERIOD_H3, OBJ_PERIOD_H4, OBJ_PERIOD_H6, OBJ_PERIOD_H8, OBJ_PERIOD_H12, OBJ_PERIOD_D1, OBJ_PERIOD_W1, OBJ_PERIOD_MN1};

//  
int periods[] = {PERIOD_M1, PERIOD_M2, PERIOD_M3, PERIOD_M4, PERIOD_M5, PERIOD_M6, PERIOD_M10, PERIOD_M12, PERIOD_M15, PERIOD_M20, PERIOD_M30, PERIOD_H1, PERIOD_H2, PERIOD_H3, PERIOD_H4, PERIOD_H6, PERIOD_H8, PERIOD_H12, PERIOD_D1, PERIOD_W1, PERIOD_MN1};

input int interval = 25;                //      
input int x_distance = 10;              //      X
input int y_distance = 10;              //      Y
input color red_zone_color = clrSalmon; //   " "
input color verical0_color = LightGray; //     0- 

struct Coord
{
  double price1;
  double price2;
  double price3;
  double price4;
  double pos1;
  double pos2;
  double pos3;
  double pos4;
};
